/*
 * WiiChuckDemo -- 
 *
 * library written in 2008 by Tod E. Kurt, http://thingm.com/
 * Customized for Bionic Arm by Frans Huntink, www.franshuntink.nl
 */

#include <Wire.h>
#include <Servo.h>
#include "nunchuck_funcs.h"

int loop_cnt=0;

byte accx,accy,zbut,cbut,joyx,joyy;
int ledPin = 13;



//Initialize all the arm variables


int servoWriteX;
int servoWriteY;
int servoWriteYaxis;
int servoYaxisOld;


Servo servoUpper;
Servo servoLower;
Servo servoTurner;
Servo servoTest;

void setup()
{
    Serial.begin(19200);
    nunchuck_setpowerpins();
    nunchuck_init(); // send the initilization handshake


    
    //This attaches the servos, make sure to use appropriate ports when using this code!
    
    servoUpper.attach(11); //Upper arm servo is attached to port 11
    servoLower.attach(10); //Lower arm servo is attached to port 10
    servoTurner.attach(12); //Turner servo (above upper) is attache to port 12
    

    
   
    //Set them in default stance on start, change this if your arm doesn't start the way you want to
    servoUpper.write(180);
    servoLower.write(180);
    servoTurner.write(90);

   


    
 
    Serial.print("Bionic arm ready\n");
}


void loop()
{

    
    if( loop_cnt > 100 ) { // every 100 msecs get new data
        loop_cnt = 0;


        //Starts initialisation of variables
        nunchuck_get_data();
        accx  = nunchuck_accelx(); // ranges from approx 70 - 182
        accy  = nunchuck_accely(); // ranges from approx 65 - 173
        zbut = nunchuck_zbutton();
        cbut = nunchuck_cbutton(); 


        
        //Custom addons by Fransh below
        joyx = nunchuck_joyx();
        joyy = nunchuck_joyy();

        
        //We shape the accx and accy values to (1,180) so it is usable by servos  180 degree angle
        servoWriteX = map(accx, 70,182,180,90); // Used for turner servo
       // servoWriteY = map(accy, 65,173,1,180); // Used for arm servos
        servoWriteY = map(accy, 75 ,185,40,180); // Used for arm servos
        servoWriteYaxis = map(joyy, 0, 200, 1, 180);
        
        
        
      //Servo movements based on nunchuck movements
       
       if ((servoWriteYaxis >= 0) and (servoWriteYaxis <= 180)) // LOWER ARM THUMBSTICK CONTROL
             {
              servoLower.write((servoWriteYaxis));
              delay(2);
             }
       
       if (cbut == 1)
       { 
              
              //Uses y axis (Up down) for Upper serv
             if ((servoWriteY >= 0) and (servoWriteY <= 180)) // UPPER ARM CONTROL
             {
                servoUpper.write(servoWriteY);
                //Serial.print(servoWriteY);
              //  Serial.print("|");
               delay(30);
           
         
                
             }
              
              
              if ((servoWriteX >= 0) and (servoWriteX <= 180)) // X AXIS OF THE ARM
              {
                servoTurner.write(servoWriteX);
                Serial.print(servoWriteX);
                delay(20);
              }
              
       


       }   
      
    
    }
    loop_cnt++;
    delay(2);
}






